#ifndef VY_ASSET_DEPENDENCIES_H
#define VY_ASSET_DEPENDENCIES_H

#include "assets.h"

#ifdef VY_DEFINE_DEPENDENCY_FILE_STRUCTURES

#include "xxhash/xxhash.h"

#pragma pack(push, 1)
typedef struct {
    uint64_t data_size;
    uint32_t num_lists;
} vy_dependency_file_header;

typedef struct {
    vy_uid uid;
    uint32_t num_entries;
    XXH64_canonical_t checksum;
} vy_dependency_file_list_header;

#pragma pack(pop)

#endif

typedef struct {
    const vy_uid *dependencies;
    uint32_t count;
} vy_asset_dependency_list;

VY_DLLEXPORT vy_asset_dependency_list vyGetAssetDependencies(vy_uid asset);

#endif
