#ifndef VY_ASSETS_H
#define VY_ASSETS_H

#include <stdint.h>

#include "runtime.h"

/* Unique identifier for an asset. */
typedef uint32_t vy_uid;

#define VY_INVALID_UID 0

/* Used to identify renderer backend dependent assets. */
enum {
    VY_INVALID_RENDERER_BACKEND_CODE = 0,
    VY_RENDERER_BACKEND_CODE_VK      = 1,

    VY_RENDERER_BACKEND_CODE_ONE_PAST_LAST,
};
typedef uint8_t vy_renderer_backend_code;

enum {
    VY_UNKNOWN_ASSET = VY_SUCCESS + 1,
    VY_BUFFER_ALLOC_FAILED,
    VY_LOAD_FAILED,
};

/* Load an asset without using the cache */
VY_DLLEXPORT vy_result vyLoadAssetDirect(vy_uid uid, void **buffer, size_t *size);

#endif