#ifndef VY_ASSETC_OPTIONS_H
#define VY_ASSETC_OPTIONS_H

#include "runtime/assets.h"

typedef enum {
    /* No optimization */
    VY_ASSET_OPTIMIZATION_NONE,

    /* Create small assets */
    VY_ASSET_OPTIMIZATION_SPACE,

    /* Create assets for fast execution */
    VY_ASSET_OPTIMIZATION_PERFORMANCE,
} vy_asset_optimization_level;

/* Options parsed from command line arguments */
typedef struct {
    const char *root_directory;
    vy_renderer_backend_code renderer_backend;
    vy_asset_optimization_level optimization;
} vy_assetc_options;

#ifndef VY_ASSETC_DONT_DEFINE_OPTIONS_GLOBAL
extern vy_assetc_options g_assetc_options;
#endif

#endif
